package com.mc.monkeynes.gui;

import com.mc.monkeynes.hardware.*;

import java.awt.*;
import java.awt.event.*;
//import java.util.*;
import javax.swing.*;
import javax.swing.event.*;



public class PatternTableViewerGui
{
  private Frame              parentFrame                      = null;
  private NesVideoMemory     vidMemory                        = null;
  private JDialog            mainDialog                       = null;
  
  private PatternTableView   patternView                      = new PatternTableView();

  public PatternTableViewerGui( Frame inParentFrame, NesVideoMemory inVidMemory )
  {
    parentFrame = inParentFrame;
    vidMemory   = inVidMemory;
    
    // Build the main view
    mainDialog.getContentPane().add( mainMenu,     BorderLayout.NORTH  );
    mainDialog.getContentPane().add( statusLabel,  BorderLayout.SOUTH );

    // Main window closing listener
    mainDialog.addWindowListener( new WindowAdapter()
    {
      public void windowClosing( WindowEvent we )
      {
        mainDialog.hide();
      }
    } );
  } // End of constructor ----------------------------------------------------------

  public void show()
  {
    // Position the window
    Dimension parentSize = parentFrame.getSize();
    Point     parentLoc  = parentFrame.getLocation();
    Dimension mySize     = new Dimension( 300, 300 );
    Point     myLoc      = new Point( (parentLoc.x + (parentSize.width / 2) - (mySize.width / 2 )), 
                                      (parentLoc.y + (parentSize.height / 2) - (mySize.height / 2 )) );
    
    // Size and position the window
    mainDialog.setLocation( myLoc );
    mainDialog.setSize( mySize );
    
    // Show the whole mess...
    mainDialog.show();
  }

}